<?php

/**
 * The public-facing functionality of the plugin.
 *
 * @link       https://www.wpconcierges.com/plugins
 * @since      1.0.0
 *
 * @package    autopopulate_checkout_woo
 * @subpackage autopopulate_checkout_woo/public
 */

/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the public-facing stylesheet and JavaScript.
 *
 * @package    autopopulate_checkout_woo
 * @subpackage autopopulate_checkout_woo/public
 * @author     Your Name <email@example.com>
 */
class autopopulate_checkout_woo_Public {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $autopopulate_checkout_woo    The ID of this plugin.
	 */
	private $autopopulate_checkout_woo;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	private $plugin_options;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $autopopulate_checkout_woo       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $autopopulate_checkout_woo, $version ) {

		$this->autopopulate_checkout_woo = $autopopulate_checkout_woo;
		$this->version = $version;
        $this->plugin_options = get_option($this->autopopulate_checkout_woo."-options",array()); 
	}

	/**
	 * Register the stylesheets for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_styles() {

		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in autopopulate_checkout_woo_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The autopopulate_checkout_woo_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */

		//wp_enqueue_style( $this->autopopulate_checkout_woo, plugin_dir_url( __FILE__ ) . 'css/autopopulate-checkout-woo-public.css', array(), $this->version, 'all' );

	}

	/**
	 * Register the JavaScript for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_scripts() {

		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in autopopulate_checkout_woo_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The autopopulate_checkout_woo_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */

		//wp_enqueue_script( $this->autopopulate_checkout_woo, plugin_dir_url( __FILE__ ) . 'js/autopopulate-checkout-woo-public.js', array( 'jquery' ), $this->version, false );

	}
	
  private function set_customer_address_field($field_type,$set_value){
  	global $woocommerce;
  
  	switch($field_type){
  	  case 'billing-first-name':
  	  $woocommerce->customer->set_billing_first_name($set_value);
  	  break;	
  	  case 'billing-last-name':
  	  $woocommerce->customer->set_billing_last_name($set_value);
  	  break;	
  	  case 'billing-company':
  	  $woocommerce->customer->set_billing_company($set_value);
  	  break;	
  	  case 'billing-address-1':
  	  $woocommerce->customer->set_billing_address_1($set_value);
  	  break;	
  	  case 'billing-address-2':
  	  $woocommerce->customer->set_billing_address_2($set_value);
  	  break;	
  	  case 'billing-city':
  	  $woocommerce->customer->set_billing_city($set_value);
  	  break;
  	  case 'billing-postcode':
  	  $woocommerce->customer->set_billing_postcode($set_value);
  	  break;
  	  case 'billing-country':
  	  $woocommerce->customer->set_billing_country($set_value);
  	  break;
  	  case 'billing-state':
  	  $woocommerce->customer->set_billing_state($set_value);
  	  break;
  	  case 'billing-email':
  	  if(is_email($set_value)){
  	   $woocommerce->customer->set_billing_email($set_value);
  	  }
  	  break;
  	  case 'billing-phone':
  	  $woocommerce->customer->set_billing_phone($set_value);
  	  break;
  	  case 'shipping-first-name':
  	  $woocommerce->customer->set_shipping_first_name($set_value);
  	  break;
  	  case 'shipping-last-name':
  	  $woocommerce->customer->set_shipping_last_name($set_value);
  	  break;
  	  case 'shipping-company':
  	  $woocommerce->customer->set_shipping_company($set_value);
  	  break;
  	  case 'shipping-address-1':
  	  $woocommerce->customer->set_shipping_address($set_value);
  	  break;
  	  case 'shipping-address-2':
  	  $woocommerce->customer->set_shipping_address_2($set_value);
  	  break;
  	  case 'shipping-postcode':
  	  $woocommerce->customer->set_shipping_postcode($set_value);
  	  break;
  	  case 'shipping-country':
  	  $woocommerce->customer->set_shipping_country($set_value);
  	  break;
  	  case 'shipping-state':
  	  $woocommerce->customer->set_shipping_state($set_value);
  	  break;	 
  	  default:
  	  error_log("field ".$field_type." not found for autopopulate checkout");
  	  break;
  	}
  
  }
  
	public function set_customer_data(){
		if ( !class_exists( 'woocommerce' ) ) { return false; } 
		
		$fields = array('acw-billing-first-name','acw-billing-last-name','acw-billing-company','acw-billing-address-1','acw-billing-address-2',
		'acw-billing-city','acw-billing-postcode','acw-billing-country','acw-billing-state','acw-billing-email','acw-billing-phone',
		'acw-shipping-first-name','acw-shipping-last-name','acw-shipping-company','acw-shipping-address-1','acw-shipping-address-2','acw-shipping-city',
		'acw-shipping-postcode','acw-shipping-country','acw-shipping-state');
    
		foreach($fields as $field){
			$is_email = false;
			if($field == 'acw-billing-email'){
				$is_email = true;
			}
		  $get_value = $this->plugin_options[$field];
		  $field_type = str_replace("acw-","",$field);
		  if(isset($_GET[$get_value]) && strlen($_GET[$get_value])){
			  if(!$is_email){
				$set_value = sanitize_text_field(urldecode($_GET[$get_value]));
				$this->set_customer_address_field($field_type,$set_value);
			  }else{
					$set_value = sanitize_email(urldecode($_GET[$get_value]));
					if(is_email($set_value)){
				  		$this->set_customer_address_field($field_type,$set_value);
					}
			  }
		  }
		}
	}
	
	public function populating_checkout_fields($fields){
		global $woocommerce;
		
		if(strlen($woocommerce->customer->get_billing_first_name()))
    $fields['billing']['billing_first_name']['default'] = $woocommerce->customer->get_billing_first_name();
    
    if(strlen($woocommerce->customer->get_billing_last_name()))
    $fields['billing']['billing_last_name']['default'] = $woocommerce->customer->get_billing_last_name();
    
    if(strlen($woocommerce->customer->get_billing_company()))
    $fields['billing']['billing_company']['default'] = $woocommerce->customer->get_billing_company();
    
    if(strlen($woocommerce->customer->get_billing_address_1()))
    $fields['billing']['billing_address_1']['default'] = $woocommerce->customer->get_billing_address_1();
    
    if(strlen($woocommerce->customer->get_billing_address_2()))
    $fields['billing']['billing_address_2']['default'] = $woocommerce->customer->get_billing_address_2();
    
    if(strlen($woocommerce->customer->get_billing_city()))
    $fields['billing']['billing_city']['default'] = $woocommerce->customer->get_billing_city();
    
    if(strlen($woocommerce->customer->get_billing_postcode()))
    $fields['billing']['billing_postcode']['default'] = $woocommerce->customer->get_billing_postcode();
    
    if(strlen($woocommerce->customer->get_billing_country()))
    $fields['billing']['billing_country']['default'] = $woocommerce->customer->get_billing_country();
    
    if(strlen($woocommerce->customer->get_billing_state()))
    $fields['billing']['billing_state']['default'] = $woocommerce->customer->get_billing_state();
    
    if(strlen($woocommerce->customer->get_billing_email()))
    $fields['billing']['billing_email']['default'] = $woocommerce->customer->get_billing_email();
    
    if(strlen($woocommerce->customer->get_billing_phone()))
    $fields['billing']['billing_phone']['default'] = $woocommerce->customer->get_billing_phone();

    if(strlen($woocommerce->customer->get_shipping_first_name()))
    $fields['shipping']['shipping_first_name']['default'] = $woocommerce->customer->get_shipping_first_name();
    
    if(strlen($woocommerce->customer->get_shipping_last_name()))
    $fields['shipping']['shipping_last_name']['default'] = $woocommerce->customer->get_shipping_last_name();
    
    if(strlen($woocommerce->customer->get_shipping_company()))
    $fields['shipping']['shipping_company']['default'] = $woocommerce->customer->get_shipping_company();
    
    if(strlen($woocommerce->customer->get_shipping_address_1()))
    $fields['shipping']['shipping_address_1']['default'] = $woocommerce->customer->get_shipping_address_1();
    
    if(strlen($woocommerce->customer->get_shipping_address_2()))
    $fields['shipping']['shipping_address_2']['default'] = $woocommerce->customer->get_shipping_address_2();
    
    if(strlen($woocommerce->customer->get_shipping_city()))
    $fields['shipping']['shipping_city']['default'] = $woocommerce->customer->get_shipping_city();
    
    if(strlen($woocommerce->customer->get_shipping_postcode()))
    $fields['shipping']['shipping_postcode']['default'] = $woocommerce->customer->get_shipping_postcode();
    
    if(strlen($woocommerce->customer->get_shipping_country()))
    $fields['shipping']['shipping_country']['default'] = $woocommerce->customer->get_shipping_country();
    
    if(strlen($woocommerce->customer->get_shipping_state()))
    $fields['shipping']['shipping_state']['default'] = $woocommerce->customer->get_shipping_state();
    
    return $fields;
	}

}
